<?php
/**
 * @file
 * Providing extra functionality for the LimeSurvey Sync module UI via views.
 */


/**
 * Implements hook_entity_views_field_handlers_alter()
 *
 * For the 'struct' limesurvey_sync datas.
 */
//Failing to create an handler for answer datas.
/*
 function limesurvey_sync_entity_views_field_handlers_alter(&$field_handlers) {
 $field_handlers += array(
 // For survey entity.
 'limesurvey_sync_lss_sync' => 'limesurvey_sync_handler_lss_sync',
 // For survey entity.
 'limesurvey_sync_survey_ls_language' => 'limesurvey_sync_handler_ls_language',
 'limesurvey_sync_survey_lss_status' => 'limesurvey_sync_handler_lss_status',
 // For token entity.
 'limesurvey_sync_token_ls_language' => 'limesurvey_sync_handler_ls_language',
 //'limesurvey_sync_token_ls_completed' => 'limesurvey_sync_handler_token_ls_completed',
 'limesurvey_sync_token_lss_status' => 'limesurvey_sync_handler_token_lss_status',
 // For answer entity.
 'limesurvey_sync_answer_ls_startlanguage' => 'limesurvey_sync_handler_ls_language',
 'limesurvey_sync_answer_lss_status' => 'limesurvey_sync_handler_answer_lss_status',
 'limesurvey_sync_answer_ls_data' => 'limesurvey_sync_handler_answer_ls_data',
 'limesurvey_sync_answer_ls_language' => 'limesurvey_sync_handler_ls_language',

 );

 }
 */
function limesurvey_sync_views_data_alter(&$data) {

  $join_field = 'ls_token';
  $entity_info = entity_get_info();
  $surveys = limesurvey_sync_survey_get_surveys();
  if ($surveys) {
    foreach ($surveys as $survey) {
      $ls_sid = $survey->ls_sid;
      $answer_entity_name = limesurvey_sync_api_entityname('answer', $ls_sid);
      $token_entity_name = limesurvey_sync_api_entityname('token', $ls_sid);
      if (array_search($join_field, $entity_info[$answer_entity_name]['schema_fields_sql']['base table']) && array_search($join_field, $entity_info[$token_entity_name]['schema_fields_sql']['base table'])) {
        $arg = array('@sid' => $ls_sid);
        $data[$answer_entity_name]['answer_token'] = array(
          'title' => t('LS token from LS answer', $arg),
          'help' => t('Provide the token entity corresponding to the answer entity with the same ls_token value'),
          'relationship' => array(
            'base' => $entity_info[$token_entity_name]['base table'], // Table we're joining to.
            'base field' => $join_field, // Field on the joined table.
            'field' => $join_field, // Real field name on the 'foo' table.
            'handler' => 'views_handler_relationship',
            'label' => t('Token @sid from answer @sid', $arg),
            //'title' => t('Title seen when adding relationship'),
            //'help' => t('More information about relationship.'),
          ),
        );
        $data[$token_entity_name]['token_answer'] = array(
          'title' => t('LS answer from LS token', $arg),
          'help' => t('Provide the answer entity corresponding to the token entity with the same ls_token value'),
          'relationship' => array(
            'base' => $entity_info[$answer_entity_name]['base table'], // Table we're joining to.
            'base field' => $join_field, // Field on the joined table.
            'field' => $join_field, // Real field name on the 'foo' table.
            'handler' => 'views_handler_relationship',
            'label' => t('Answer @sid from token @sid', $arg),
            //'title' => t('Title seen when adding relationship'),
            //'help' => t('More information about relationship.'),
          ),
        );
      }
    }
  }
  /*
   foreach(limesurvey_sync_survey_get_surveys() as $survey) {
   $answer_entity_type = limesurvey_sync_api_entityname('answer', $survey->ls_sid);
   foreach ($data[$answer_entity_type] as $field => $properties) {
   $ls_fields = (strpos($field, 'ls_'.$survey->ls_sid) === 0);
   if ($ls_fields && empty($properties['field']['options callback'])) {
   // If an option list is not defined, use the render function.
   $data[$answer_entity_type][$field]['handler'] = 'limesurvey_sync_views_handler_field_answer_data';
   }
   }
   }
   */
}

